 /*
 * Copyright (C) 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

/** @cond OLPLUGIN */
/** @addtogroup UI_utils */
/** @{ */


#define SCHEDULER_DEFAULT_MINUTES 15


#define SYNC_DEFAULT_TOTAL_ITEMS  20

// Default dimensions of frames (in case of 96dpi)
#define FRAME_CONFIG_X 440
#define FRAME_CONFIG_Y 382
#define FRAME_MAIN_X 350
#define FRAME_MAIN_Y 350

#define MAIN_PROGRESSBAR_COLOR RGB(255,255,255)

#define EDIT_TEXT_MAXLENGTH 255
#define EDIT_TEXT_SCHEDULER_MAXLENGTH 6

#define SYNCTYPE_NONE "none"

//#define LAST_SYNC_TIME_FORMAT TEXT("%A %#d %b %Y %#I:%M%p")
//#define LAST_SYNC_TIME_FORMAT TEXT("%#d %b %Y %#I:%M%p")
#define LAST_SYNC_TIME_FORMAT TEXT("%A, %#I:%M%p")


int getSyncTypeIndex(const char* syncType);

const char* getSyncTypeName    (int index);
const char* getFullSyncTypeName(int index);

int getSyncModeCode(const char* syncMode);

void manageSyncErrorMsg(long code);

CPoint getRelativePosition(CWnd* wnd, CWnd* parentWnd);

/** @} */
/** @endcond */
