 /*
 * Copyright (C) 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

#pragma once

/** @cond OLPLUGIN */
/** @addtogroup UI */
/** @{ */


enum PANE_STATE {STATE_NORMAL, STATE_SYNC, STATE_PANE_DISABLED, STATE_PANE_HIDDEN};
enum PANE_TYPE {PANE_TYPE_SYNC, PANE_TYPE_CONTACTS, PANE_TYPE_CALENDAR, PANE_TYPE_TASKS, PANE_TYPE_NOTES};

/**
 * Panes (active source buttons) on main window.
 */
class CCustomPane : public CStatic
{
	DECLARE_DYNAMIC(CCustomPane)

public:
    bool bMouseCaptured;
    bool bSourcePane;
    int state;
    int type;
    HICON hPrevStatusIcon;
	CCustomPane();   
	virtual ~CCustomPane();


protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg LRESULT OnMouseLeave(WPARAM, LPARAM);
    afx_msg void OnPaint( );
};

/** @} */
/** @endcond */
