 /*
 * Copyright (C) 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

/** @cond OLPLUGIN */
/** @addtogroup UI */
/** @{ */

#pragma once
#include "afxwin.h"


/**
 * Notes options window.
 */
class CNotesSettings : public CDialog
{
	DECLARE_DYNCREATE(CNotesSettings)

public:
	CNotesSettings();           
	virtual ~CNotesSettings();

	enum { IDD = IDD_NOTES };
#ifdef _DEBUG
	virtual void AssertValid() const;
#ifndef _WIN32_WCE
	virtual void Dump(CDumpContext& dc) const;
#endif
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL OnInitDialog();

    DECLARE_MESSAGE_MAP()

    CComboBox lstSyncType;
    CEdit editFolder;
    CButton checkInclude;
    CButton butSelectFolder;
    CEdit editRemote;
    CStatic groupDirection;
    CStatic groupFolder;
    CStatic groupAdvanced;

public:
    bool saveSettings(bool);
    afx_msg void OnBnClickedNotesOk();
    afx_msg void OnBnClickedNotesCancel();
    afx_msg void OnBnClickedNotesButSelect();    
};

/** @} */
/** @endcond */

