 /*
 * Copyright (C) 2006-2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

#include "event/OutlookTransportListener.h"
#include "base/Log.h"
#include "winmaincpp.h"
#include "HwndFunctions.h"


void OutlookTransportListener::sendDataBegin(TransportEvent &event) {
	LOG.debug("Sending data of size %d...", event.getDataSize());
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_REFRESH_STATUSBAR, NULL, (LPARAM)SBAR_SENDDATA_BEGIN);
}

void OutlookTransportListener::syncDataEnd(TransportEvent &event) {
	LOG.debug("Finished sending data of size %d.", event.getDataSize());
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_REFRESH_STATUSBAR, NULL, (LPARAM)SBAR_SENDDATA_END);
    checkAbortedSync();
}

void OutlookTransportListener::receiveDataBegin(TransportEvent &event) {
    LOG.debug("Receiving data of size %d...", event.getDataSize());
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_REFRESH_STATUSBAR, NULL, (LPARAM)SBAR_RECEIVE_DATA_BEGIN);
    checkAbortedSync();
}

void OutlookTransportListener::receivingData(TransportEvent &event) {
    //LOG.debug("Reading %d bytes...", event.getDataSize());
}

void OutlookTransportListener::receiveDataEnd(TransportEvent &event) {
    LOG.debug("Finished receiving data of size %d.", event.getDataSize());
    //SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_REFRESH_STATUSBAR, NULL, (LPARAM)SBAR_RECEIVE_DATA_END);
}

