 /*
 * Copyright (C) 2006-2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

#ifndef INCL_UTILS_OL
#define INCL_UTILS_OL

/** @cond OLPLUGIN */
/** @addtogroup outlook_utils */
/** @{ */


// Timezones that are changing their rule in 2007
#define TZ_EASTERN_US           TEXT("Eastern Standard Time" )
#define TZ_CENTRAL_US           TEXT("Central Standard Time" )
#define TZ_MOUNTAIN             TEXT("Mountain Standard Time")
#define TZ_PACIFIC_US           TEXT("Pacific Standard Time" )
#define TZ_ALASKA               TEXT("Alaska Standard Time"  )


#include "base/fscapi.h"
#include "outlook/defs.h"
#include "winmaincpp.h"

#include <string>


// Item types conversions.
const OlDefaultFolders  getDefaultFolderType (const std::wstring& itemType);
const OlItemType        getOlItemType        (const std::wstring& itemType);
const std::wstring      getItemTypeFromOlType(const OlItemType olType);

void manageComErrors(_com_error &e);
const std::wstring getNameFromVersion(std::wstring version);


// DATE/TIME conversions.
void doubleToSystemTime(std::wstring& systemDate, const DATE doubleDate, const BOOL toUTC, const bool onlyDate = false);
void systemTimeToDouble(const std::wstring& dataString, DATE* date, bool onlyDate = false);
void localTimeToUTC    (SYSTEMTIME &sysTime);
void UTCToLocalTime    (SYSTEMTIME &sysTime);
bool adjustDSTSettings (TIME_ZONE_INFORMATION* timeZoneInfo, SYSTEMTIME targetTime);
bool isTZForDSTChange  (const std::wstring& tzName);


// Boolean conversions.
BOOL         vBoolToBOOL(VARIANT_BOOL vbool);
bool         vBoolToBool(VARIANT_BOOL vbool);
VARIANT_BOOL BOOLToVBool(BOOL b);


/** @} */
/** @endcond */
#endif